package de.itstall;

import de.itstall.model.Kontakt;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;

import java.util.ArrayList;

public class TelefonbuchController {

	private Kontakt kontakt = new Kontakt();

	@FXML
	private TextField txtVorname;

	@FXML
	private TextField txtNachname;

	@FXML
	private TextField txtStrasse;

	@FXML
	private TextField txtHNr;

	@FXML
	private TextField txtPlz;

	@FXML
	private TextField txtOrt;

	@FXML
	private TextField txtTelefon;

	@FXML
	private Button btnNaviLinks;

	@FXML
	private Button btnNaviRechts;

	@FXML
	private Button btnNeuerEintrag;

	@FXML
	private Button btnLoeschen;

	@FXML
	void loeschen(ActionEvent event) {
		deleteKontakt();
	}

	@FXML
	void navWeiter(ActionEvent event) {
		kontakt = App.eintraege.get(sucheEintrag(kontakt.getTelefon())[1]);
		setForm(kontakt);
	}

	@FXML
	void navZurueck(ActionEvent event) {
		kontakt = App.eintraege.get(sucheEintrag(kontakt.getTelefon())[0]);
		setForm(kontakt);
	}

	@FXML
	void neuerEintrag(ActionEvent event) {
		neuenKontaktAnlegen();
	}

	@FXML
	void initialize() {
		assert txtVorname != null : "fx:id=\"txtVorname\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtNachname != null : "fx:id=\"txtNachname\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtStrasse != null : "fx:id=\"txtStrasse\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtHNr != null : "fx:id=\"txtHNr\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtPlz != null : "fx:id=\"txtPlz\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtOrt != null : "fx:id=\"txtOrt\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert txtTelefon != null : "fx:id=\"txtTelefon\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert btnNaviLinks != null : "fx:id=\"btnNaviLinks\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert btnNaviRechts != null : "fx:id=\"btnNaviRechts\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert btnNeuerEintrag != null : "fx:id=\"btnNeuerEintrag\" was not injected: check your FXML file 'telefonbuch.fxml'.";
		assert btnLoeschen != null : "fx:id=\"btnLoeschen\" was not injected: check your FXML file 'telefonbuch.fxml'.";

		txtVorname.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setVorname(txtVorname.getText())) {
					setFieldError(txtVorname, true);
				} else {
					saveKontakt();
					setFieldError(txtVorname, false);
				}
			}
		});

		txtNachname.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setNachname(txtNachname.getText())) {
					setFieldError(txtNachname, true);
				} else {
					saveKontakt();
					setFieldError(txtNachname, false);
				}
			}
		});

		txtStrasse.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setStrasse(txtStrasse.getText())) {
					setFieldError(txtStrasse, true);
				} else {
					saveKontakt();
					setFieldError(txtStrasse, false);
				}
			}
		});

		txtHNr.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setHausnummer(txtHNr.getText())) {
					setFieldError(txtHNr, true);
				} else {
					saveKontakt();
					setFieldError(txtHNr, false);
				}
			}
		});

		txtPlz.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setPlz(txtPlz.getText())) {
					setFieldError(txtPlz, true);
				} else {
					saveKontakt();
					setFieldError(txtPlz, false);
				}
			}
		});

		txtOrt.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (!kontakt.setOrt(txtOrt.getText())) {
					setFieldError(txtOrt, true);
				} else {
					saveKontakt();
					setFieldError(txtOrt, false);
				}
			}
		});

		txtTelefon.focusedProperty().addListener((observableValue, aBoolean, t1) -> {
			if (!t1) {
				if (txtTelefon.getText() != kontakt.getTelefon()) {
					deleteKontakt();
					saveKontakt();
				}
				if (!kontakt.setTelefon(txtTelefon.getText())) {
					setFieldError(txtTelefon, true);
				} else {
					saveKontakt();
					setFieldError(txtTelefon, false);
				}
			}
		});
	}

	/**
	 * Legt ein neues Kontakt Object an
	 */
	private void neuenKontaktAnlegen() {
		resetForm();
	}

	/**
	 * Kontakt aus Treemap loeschen
	 */
	public void deleteKontakt() {
		App.eintraege.remove(txtTelefon.getText());
		resetForm();
	}

	/**
	 * Kontakt in die Treemap speichern
	 */
	public void saveKontakt() {
		if (kontakt.getTelefon() != "") {
			App.eintraege.put(kontakt.getTelefon(), kontakt);
		}
	}

	/**
	 * Background der Felder setzen im Fehler Fall
	 *
	 * @param field : Textfeld Object
	 * @param set   : true:Fehler false:Kein Fehler
	 */
	public void setFieldError(TextField field, boolean set) {
		if (set) {
			field.setStyle("-fx-control-inner-background: #ff000040;");
		} else {
			field.setStyle("-fx-control-inner-background: WHITE;");
		}
	}

	/**
	 * Suche die naechste und die letzte Nummer aus der Treemap
	 *
	 * @param telefon : String : Gesuchte Telefonnummer
	 * @return
	 */
	public String[] sucheEintrag(String telefon) {
		/** Initialisieren des Rueckgabe Arrays */
		String rueckgabe[] = new String[2];

		/** Arraylist als temporaeren Speicher anlegen */
		ArrayList<String> telefonbuch = new ArrayList<>();

		/** Kopiert die Keys (Telefonnummern) der Treemap in eine Arraylist zum einfacheren durchsuchen */
		for (String tnr : App.eintraege.keySet()) {
			telefonbuch.add(tnr);
		}

		/**
		 * Uebergebene Telefonnummer ist nicht gesetzt (Leeres Formular) oder existiert nicht
		 * Zurueck = letzter Eintrag | Weiter = erster Eintrag
		 */
		if (telefon.equals("") || telefon == null || !telefonbuch.contains(telefon)) {
			/** Pruefung ob mehr als ein Eintrag vorhanden */
			if (telefonbuch.size() > 1) {
				rueckgabe[0] = telefonbuch.get(telefonbuch.size() - 1);
				rueckgabe[1] = telefonbuch.get(0);
			}
			/** Nur ein Eintrag vorhanden also diesen Eintrag als zurueck/weiter zurueck geben */
			else {
				rueckgabe[0] = rueckgabe[1] = telefonbuch.get(0);
			}
		} else {
			/** Das Telefonbuch hat nur einen Eintrag */
			if (telefonbuch.size() == 1) {
				rueckgabe[0] = telefonbuch.get(0);
				rueckgabe[1] = telefonbuch.get(0);
			}
			/** Gesuchte Nummer ist an Index 0 */
			else if (telefonbuch.indexOf(telefon) == 0) {
				rueckgabe[0] = telefonbuch.get(telefonbuch.size() - 1);
				rueckgabe[1] = telefonbuch.get(telefonbuch.indexOf(telefon) + 1);
			}
			/** Gesuchte Nummer ist am letzten Index */
			else if (telefonbuch.indexOf(telefon) == telefonbuch.size() - 1) {
				rueckgabe[0] = telefonbuch.get(telefonbuch.indexOf(telefon) - 1);
				rueckgabe[1] = telefonbuch.get(0);
			}
			/** Gesuchte Nummer befindet sich irgendwo im Array und nicht am ersten/letzten Index */
			else {
				rueckgabe[0] = telefonbuch.get(telefonbuch.indexOf(telefon) - 1);
				rueckgabe[1] = telefonbuch.get(telefonbuch.indexOf(telefon) + 1);
			}
		}

		return rueckgabe;
	}

	/**
	 * Loescht das Formular und erstellt ein neues Kontakt Objekt
	 */
	public void resetForm() {
		kontakt = new Kontakt();
		txtVorname.setText("");
		txtNachname.setText("");
		txtStrasse.setText("");
		txtHNr.setText("");
		txtPlz.setText("");
		txtOrt.setText("");
		txtTelefon.setText("");
	}

	/**
	 * Setzt alle Formular Felder auf die Daten des Objektes
	 *
	 * @param kontakt
	 */
	public void setForm(Kontakt kontakt) {
		txtVorname.setText(kontakt.getVorname());
		txtNachname.setText(kontakt.getNachname());
		txtStrasse.setText(kontakt.getStrasse());
		txtHNr.setText(kontakt.getHausnummer());
		txtPlz.setText(kontakt.getPlz());
		txtOrt.setText(kontakt.getOrt());
		txtTelefon.setText(kontakt.getTelefon());
	}
}
