package de.itstall.model;

public class Kontakt {
	// region 0 Variables
	private String vorname, nachname, strasse, hausnummer, plz, ort, telefon = "";
	//endregion

	// region 1 Setter
	public boolean setVorname(String vorname) {
		if (vorname.length() <= 50) {
			this.vorname = vorname;
			return true;
		} else {
			return false;
		}
	}

	public boolean setNachname(String nachname) {
		if (nachname.length() <= 50) {
			this.nachname = nachname;
			return true;
		} else {
			return false;
		}
	}

	public boolean setStrasse(String strasse) {
		if (strasse.length() <= 50) {
			this.strasse = strasse;
			return true;
		} else {
			return false;
		}
	}

	public boolean setHausnummer(String hausnummer) {
		if (hausnummer.length() <= 10) {
			this.hausnummer = hausnummer;
			return true;
		} else {
			return false;
		}
	}

	public boolean setPlz(String plz) {
		if (plz.length() == 5) {
			this.plz = plz;
			return true;
		} else {
			return false;
		}
	}

	public boolean setOrt(String ort) {
		if (ort.length() <= 50) {
			this.ort = ort;
			return true;
		} else {
			return false;
		}
	}

	public boolean setTelefon(String telefon) {
		if (telefon.length() <= 30 && telefon.length() > 2 && isNumeric(telefon)) {
			this.telefon = telefon;
			return true;
		} else {
			return false;
		}
	}
	//endregion

	// region 2. Getter
	public String getVorname() {
		return vorname;
	}

	public String getNachname() {
		return nachname;
	}

	public String getStrasse() {
		return strasse;
	}

	public String getHausnummer() {
		return hausnummer;
	}

	public String getPlz() {
		return plz;
	}

	public String getOrt() {
		return ort;
	}

	public String getTelefon() {
		return telefon;
	}
	//endregion

	//region 3 Functions
	/**
	 * Prueft ob String aus Zahlen besteht
	 */
	public boolean isNumeric(String s) {
		return s != null && s.matches("[-+]?\\d*\\.?\\d+");
	}
	//endregion
}
